OGRE: Ogre::Material Class Reference - OGRE Documentation

Public Types | Public Member Functions | Static Public Member Functions | Protected Types | Protected Member Functions | Protected Attributes | Friends

# Ogre::Material Class Reference
[Materials]

Class encapsulates rendering properties of an object. More...

`#include <OgreMaterial.h>`

Inheritance diagram for Ogre::Material:
[legend]

List of all members.

## Public Types
typedef vector< Real >::type | LodValueList
| distance list used to specify LOD
typedef ConstVectorIterator < LodValueList > | LodValueIterator
typedef VectorIterator < Techniques > | TechniqueIterator
enum | LoadingState { LOADSTATE_UNLOADED, LOADSTATE_LOADING, LOADSTATE_LOADED, LOADSTATE_UNLOADING, LOADSTATE_PREPARED, LOADSTATE_PREPARING }
| Enum identifying the loading state of the resource. More...
## Public Member Functions
| Material (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Constructor - use resource manager's create method rather than this.
| ~Material ()
Material & | operator= (const Material &rhs)
| Assignment operator to allow easy copying between materials.
bool | isTransparent (void) const
| Determines if the material has any transparency with the rest of the scene (derived from whether any Techniques say they involve transparency).
void | setReceiveShadows (bool enabled)
| Sets whether objects using this material will receive shadows.
bool | getReceiveShadows (void) const
| Returns whether or not objects using this material will receive shadows.
void | setTransparencyCastsShadows (bool enabled)
| Sets whether objects using this material be classified as opaque to the shadow caster system.
bool | getTransparencyCastsShadows (void) const
| Returns whether or not objects using this material be classified as opaque to the shadow caster system.
Technique * | createTechnique (void)
| Creates a new Technique for this Material.
Technique * | getTechnique (unsigned short index)
| Gets the indexed technique.
Technique * | getTechnique (const String &name)
| searches for the named technique.
unsigned short | getNumTechniques (void) const
| Retrieves the number of techniques.
void | removeTechnique (unsigned short index)
| Removes the technique at the given index.
void | removeAllTechniques (void)
| Removes all the techniques in this Material.
TechniqueIterator | getTechniqueIterator (void)
| Get an iterator over the Techniques in this Material.
TechniqueIterator | getSupportedTechniqueIterator (void)
| Gets an iterator over all the Techniques which are supported by the current card.
Technique * | getSupportedTechnique (unsigned short index)
| Gets the indexed supported technique.
unsigned short | getNumSupportedTechniques (void) const
| Retrieves the number of supported techniques.
const String & | getUnsupportedTechniquesExplanation () const
| Gets a string explaining why any techniques are not supported.
unsigned short | getNumLodLevels (unsigned short schemeIndex) const
| Gets the number of levels-of-detail this material has in the given scheme, based on Technique::setLodIndex.
unsigned short | getNumLodLevels (const String &schemeName) const
| Gets the number of levels-of-detail this material has in the given scheme, based on Technique::setLodIndex.
Technique * | getBestTechnique (unsigned short lodIndex=0, const Renderable *rend=0)
| Gets the best supported technique.
MaterialPtr | clone (const String &newName, bool changeGroup=false, const String &newGroup=StringUtil::BLANK) const
| Creates a new copy of this material with the same settings but a new name.
void | copyDetailsTo (MaterialPtr &mat) const
| Copies the details of this material into another, preserving the target's handle and name (unlike operator=) but copying everything else.
void | compile (bool autoManageTextureUnits=true)
| 'Compiles' this Material.
void | setPointSize (Real ps)
| Sets the point size properties for every Pass in every Technique.
void | setAmbient (Real red, Real green, Real blue)
| Sets the ambient colour reflectance properties for every Pass in every Technique.
void | setAmbient (const ColourValue &ambient)
| Sets the ambient colour reflectance properties for every Pass in every Technique.
void | setDiffuse (Real red, Real green, Real blue, Real alpha)
| Sets the diffuse colour reflectance properties of every Pass in every Technique.
void | setDiffuse (const ColourValue &diffuse)
| Sets the diffuse colour reflectance properties of every Pass in every Technique.
void | setSpecular (Real red, Real green, Real blue, Real alpha)
| Sets the specular colour reflectance properties of every Pass in every Technique.
void | setSpecular (const ColourValue &specular)
| Sets the specular colour reflectance properties of every Pass in every Technique.
void | setShininess (Real val)
| Sets the shininess properties of every Pass in every Technique.
void | setSelfIllumination (Real red, Real green, Real blue)
| Sets the amount of self-illumination of every Pass in every Technique.
void | setSelfIllumination (const ColourValue &selfIllum)
| Sets the amount of self-illumination of every Pass in every Technique.
void | setDepthCheckEnabled (bool enabled)
| Sets whether or not each Pass renders with depth-buffer checking on or not.
void | setDepthWriteEnabled (bool enabled)
| Sets whether or not each Pass renders with depth-buffer writing on or not.
void | setDepthFunction (CompareFunction func)
| Sets the function used to compare depth values when depth checking is on.
void | setColourWriteEnabled (bool enabled)
| Sets whether or not colour buffer writing is enabled for each Pass.
void | setCullingMode (CullingMode mode)
| Sets the culling mode for each pass based on the 'vertex winding'.
void | setManualCullingMode (ManualCullingMode mode)
| Sets the manual culling mode, performed by CPU rather than hardware.
void | setLightingEnabled (bool enabled)
| Sets whether or not dynamic lighting is enabled for every Pass.
void | setShadingMode (ShadeOptions mode)
| Sets the type of light shading required.
void | setFog (bool overrideScene, FogMode mode=FOG_NONE, const ColourValue &colour=ColourValue::White, Real expDensity=0.001, Real linearStart=0.0, Real linearEnd=1.0)
| Sets the fogging mode applied to each pass.
void | setDepthBias (float constantBias, float slopeScaleBias)
| Sets the depth bias to be used for each Pass.
void | setTextureFiltering (TextureFilterOptions filterType)
| Set texture filtering for every texture unit in every Technique and Pass.
void | setTextureAnisotropy (int maxAniso)
| Sets the anisotropy level to be used for all textures.
void | setSceneBlending (const SceneBlendType sbt)
| Sets the kind of blending every pass has with the existing contents of the scene.
void | setSeparateSceneBlending (const SceneBlendType sbt, const SceneBlendType sbta)
| Sets the kind of blending every pass has with the existing contents of the scene, using individual factors for color and alpha channels.
void | setSceneBlending (const SceneBlendFactor sourceFactor, const SceneBlendFactor destFactor)
| Allows very fine control of blending every Pass with the existing contents of the scene.
void | setSeparateSceneBlending (const SceneBlendFactor sourceFactor, const SceneBlendFactor destFactor, const SceneBlendFactor sourceFactorAlpha, const SceneBlendFactor destFactorAlpha)
| Allows very fine control of blending every Pass with the existing contents of the scene, using individual factors for color and alpha channels.
void | _notifyNeedsRecompile (void)
| Tells the material that it needs recompilation.
void | setLodLevels (const LodValueList &lodValues)
| Sets the distance at which level-of-detail (LOD) levels come into effect.
LodValueIterator | getLodValueIterator (void) const
| Gets an iterator over the list of values at which each LOD comes into effect.
ushort | getLodIndex (Real value) const
| Gets the LOD index to use at the given value.
const LodStrategy * | getLodStrategy () const
| Get lod strategy used by this material.
void | setLodStrategy (LodStrategy *lodStrategy)
| Set the lod strategy used by this material.
void | touch (void)
bool | applyTextureAliases (const AliasTextureNamePairList &aliasList, const bool apply=true) const
| Applies texture names to Texture Unit State with matching texture name aliases.
bool | getCompilationRequired () const
| Gets the compilation status of the material.
virtual void | prepare (bool backgroundThread=false)
| Prepares the resource for load, if it is not already.
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already.
virtual void | reload (void)
| Reloads the resource, if it is already loaded.
virtual bool | isReloadable (void) const
| Returns true if the Resource is reloadable, false otherwise.
virtual bool | isManuallyLoaded (void) const
| Is this resource manually loaded?
virtual void | unload (void)
| Unloads the resource; this is not permanent, the resource can be reloaded later if required.
virtual size_t | getSize (void) const
| Retrieves info about the size of the resource.
virtual const String & | getName (void) const
| Gets resource name.
virtual ResourceHandle | getHandle (void) const
virtual bool | isPrepared (void) const
| Returns true if the Resource has been prepared, false otherwise.
virtual bool | isLoaded (void) const
| Returns true if the Resource has been loaded, false otherwise.
virtual bool | isLoading () const
| Returns whether the resource is currently in the process of background loading.
virtual LoadingState | getLoadingState () const
| Returns the current loading state.
virtual bool | isBackgroundLoaded (void) const
| Returns whether this Resource has been earmarked for background loading.
virtual void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not.
virtual void | escalateLoading ()
| Escalates the loading of a background loaded resource.
virtual void | addListener (Listener *lis)
| Register a listener on this resource.
virtual void | removeListener (Listener *lis)
| Remove a listener on this resource.
virtual const String & | getGroup (void)
| Gets the group which this resource is a member of.
virtual void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource.
virtual ResourceManager * | getCreator (void)
| Gets the manager which created this resource.
virtual const String & | getOrigin (void) const
| Get the origin of this resource, e.g.
virtual void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin.
virtual size_t | getStateCount () const
| Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.
virtual void | _dirtyState ()
| Manually mark the state of this resource as having been changed.
virtual void | _fireLoadingComplete (bool wasBackgroundLoaded)
| Firing of loading complete event.
virtual void | _firePreparingComplete (bool wasBackgroundLoaded)
| Firing of preparing complete event.
virtual void | _fireUnloadingComplete (void)
| Firing of unloading complete event.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Static Public Member Functions
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.
## Protected Types
typedef vector< Technique * >::type | Techniques
typedef map< unsigned short, Technique * >::type | LodTechniques
typedef map< unsigned short, LodTechniques * >::type | BestTechniquesBySchemeList
typedef list< Listener * >::type | ListenerList
## Protected Member Functions
void | applyDefaults (void)
| Internal method which sets the material up from the default settings.
void | insertSupportedTechnique (Technique *t)
| Insert a supported technique into the local collections.
void | clearBestTechniqueList (void)
| Clear the best technique list.
void | prepareImpl (void)
| Overridden from Resource.
void | unprepareImpl (void)
| Overridden from Resource.
void | loadImpl (void)
| Overridden from Resource.
void | unloadImpl (void)
| Unloads the material, frees resources etc.
size_t | calculateSize (void) const
virtual void | preLoadImpl (void)
| Internal hook to perform actions before the load process, but after the resource has been marked as 'loading'.
virtual void | postLoadImpl (void)
| Internal hook to perform actions after the load process, but before the resource has been marked as fully loaded.
virtual void | preUnloadImpl (void)
| Internal hook to perform actions before the unload process.
virtual void | postUnloadImpl (void)
| Internal hook to perform actions after the unload process, but before the resource has been marked as fully unloaded.
bool | createParamDictionary (const String &className)
| Internal method for creating a parameter dictionary for the class, if it does not already exist.
## Protected Attributes
Techniques | mTechniques
| All techniques, supported and unsupported.
Techniques | mSupportedTechniques
| Supported techniques of any sort.
BestTechniquesBySchemeList | mBestTechniquesBySchemeList
| Map of scheme -> list of LOD techniques.
LodValueList | mUserLodValues
LodValueList | mLodValues
const LodStrategy * | mLodStrategy
bool | mReceiveShadows
bool | mTransparencyCastsShadows
bool | mCompilationRequired
| Does this material require compilation?
String | mUnsupportedReasons
| Text description of why any techniques are not supported.
ResourceManager * | mCreator
| Creator.
String | mName
| Unique name of the resource.
String | mGroup
| The name of the resource group.
ResourceHandle | mHandle
| Numeric handle for more efficient look up than name.
AtomicScalar< LoadingState > | mLoadingState
| Is the resource currently loaded?
volatile bool | mIsBackgroundLoaded
| Is this resource going to be background loaded? Only applicable for multithreaded.
size_t | mSize
| The size of the resource in bytes.
bool | mIsManual
| Is this file manually loaded?
String | mOrigin
| Origin of this resource (e.g. script name) - optional.
ManualResourceLoader * | mLoader
| Optional manual loader; if provided, data is loaded from here instead of a file.
size_t | mStateCount
| State count, the number of times this resource has changed state.
ListenerList | mListenerList
## Friends
class | SceneManager
class | MaterialManager

## Detailed Description

Class encapsulates rendering properties of an object.

Remarks:
  Ogre's material class encapsulates ALL aspects of the visual appearance, of an object. It also includes other flags which might not be traditionally thought of as material properties such as culling modes and depth buffer settings, but these affect the appearance of the rendered object and are convenient to attach to the material since it keeps all the settings in one place. This is different to Direct3D which treats a material as just the colour components (diffuse, specular) and not texture maps etc. An Ogre Material can be thought of as equivalent to a 'Shader'.

  A Material can be rendered in multiple different ways depending on the hardware available. You may configure a Material to use high-complexity fragment shaders, but these won't work on every card; therefore a Technique is an approach to creating the visual effect you are looking for. You are advised to create fallback techniques with lower hardware requirements if you decide to use advanced features. In addition, you also might want lower-detail techniques for distant geometry.

  Each technique can be made up of multiple passes. A fixed-function pass may combine multiple texture layers using multitexrtuing, but Ogre can break that into multiple passes automatically if the active card cannot handle that many simultaneous textures. Programmable passes, however, cannot be split down automatically, so if the active graphics card cannot handle the technique which contains these passes, OGRE will try to find another technique which the card can do. If, at the end of the day, the card cannot handle any of the techniques which are listed for the material, the engine will render the geometry plain white, which should alert you to the problem.

  Ogre comes configured with a number of default settings for a newly created material. These can be changed if you wish by retrieving the default material settings through SceneManager::getDefaultMaterialSettings. Any changes you make to the Material returned from this method will apply to any materials created from this point onward.

Definition at line 88 of file OgreMaterial.h.

## Member Typedef Documentation

typedef map<unsigned short, LodTechniques*>::type Ogre::Material::BestTechniquesBySchemeList`[protected]`

Definition at line 110 of file OgreMaterial.h.

typedef list<Listener*>::type Ogre::Resource::ListenerList`[protected, inherited]`

Definition at line 164 of file OgreResource.h.

typedef map<unsigned short, Technique*>::type Ogre::Material::LodTechniques`[protected]`

Definition at line 109 of file OgreMaterial.h.

typedef ConstVectorIterator<LodValueList> Ogre::Material::LodValueIterator

Definition at line 96 of file OgreMaterial.h.

typedef vector<Real>::type Ogre::Material::LodValueList

distance list used to specify LOD

Definition at line 95 of file OgreMaterial.h.

typedef VectorIterator<Techniques> Ogre::Material::TechniqueIterator

Definition at line 226 of file OgreMaterial.h.

typedef vector<Technique*>::type Ogre::Material::Techniques`[protected]`

Definition at line 104 of file OgreMaterial.h.

## Member Enumeration Documentation

enum Ogre::Resource::LoadingState`[inherited]`

Enum identifying the loading state of the resource.

Enumerator:

  LOADSTATE_UNLOADED | Not loaded.
  LOADSTATE_LOADING | Loading is in progress.
  LOADSTATE_LOADED | Fully loaded.
  LOADSTATE_UNLOADING | Currently unloading.
  LOADSTATE_PREPARED | Fully prepared.
  LOADSTATE_PREPARING | Preparing is in progress.

Definition at line 125 of file OgreResource.h.

## Constructor & Destructor Documentation

Ogre::Material::Material | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0` |
| ) |  |  |

Constructor - use resource manager's create method rather than this.

Ogre::Material::~Material | ( |  | ) |

## Member Function Documentation

virtual void Ogre::Resource::_dirtyState | ( |  | ) | `[virtual, inherited]`

Manually mark the state of this resource as having been changed.

Remarks:
  You only need to call this from outside if you explicitly want derived objects to think this object has changed.

See also:
  getStateCount.

virtual void Ogre::Resource::_fireLoadingComplete | ( | bool | wasBackgroundLoaded | ) | `[virtual, inherited]`

Firing of loading complete event.

Remarks:
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

Parameters:

  | wasBackgroundLoaded | Whether this was a background loaded event

virtual void Ogre::Resource::_firePreparingComplete | ( | bool | wasBackgroundLoaded | ) | `[virtual, inherited]`

Firing of preparing complete event.

Remarks:
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

Parameters:

  | wasBackgroundLoaded | Whether this was a background loaded event

virtual void Ogre::Resource::_fireUnloadingComplete | ( | void |  | ) | `[virtual, inherited]`

Firing of unloading complete event.

Remarks:
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

void Ogre::Material::_notifyNeedsRecompile | ( | void |  | ) |

Tells the material that it needs recompilation.

virtual void Ogre::Resource::_notifyOrigin | ( | const String & | origin | ) | `[virtual, inherited]`

Notify this resource of it's origin.

Definition at line 420 of file OgreResource.h.

virtual void Ogre::Resource::addListener | ( | Listener * | lis | ) | `[virtual, inherited]`

Register a listener on this resource.

See also:
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

void Ogre::Material::applyDefaults | ( | void |  | ) | `[protected]`

Internal method which sets the material up from the default settings.

bool Ogre::Material::applyTextureAliases | ( | const AliasTextureNamePairList & | aliasList,
|  | const bool | apply = `true` |
| ) |  |  | const

Applies texture names to Texture Unit State with matching texture name aliases.

All techniques, passes, and Texture Unit States within the material are checked. If matching texture aliases are found then true is returned.

Parameters:

  | aliasList | is a map container of texture alias, texture name pairs
  | apply | set true to apply the texture aliases else just test to see if texture alias matches are found.

Returns:
  True if matching texture aliases were found in the material.

size_t Ogre::Material::calculateSize | ( | void |  | ) | const`[protected, virtual]`

Calculate the size of a resource; this will only be called after 'load'.

Implements Ogre::Resource.

Definition at line 152 of file OgreMaterial.h.

virtual void Ogre::Resource::changeGroupOwnership | ( | const String & | newGroup | ) | `[virtual, inherited]`

Change the resource group ownership of a Resource.

Remarks:
  This method is generally reserved for internal use, although if you really know what you're doing you can use it to move this resource from one group to another.

Parameters:

  | newGroup | Name of the new group

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) | `[static, inherited]`

Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

MaterialManager) initializes.

void Ogre::Material::clearBestTechniqueList | ( | void |  | ) | `[protected]`

Clear the best technique list.

MaterialPtr Ogre::Material::clone | ( | const String & | newName,
|  | bool | changeGroup = `false`,
|  | const String & | newGroup = `StringUtil::BLANK` |
| ) |  |  | const

Creates a new copy of this material with the same settings but a new name.

Parameters:

  | newName | The name for the cloned material
  | changeGroup | If true, the resource group of the clone is changed
  | newGroup | Only required if changeGroup is true; the new group to assign

void Ogre::Material::compile | ( | bool | autoManageTextureUnits = `true` | ) |

'Compiles' this Material.

Remarks:
  Compiling a material involves determining which Techniques are supported on the card on which OGRE is currently running, and for fixed-function Passes within those Techniques, splitting the passes down where they contain more TextureUnitState instances than the current card has texture units.

  This process is automatically done when the Material is loaded, but may be repeated if you make some procedural changes.

Parameters:

  | autoManageTextureUnits | If true, when a fixed function pass has too many TextureUnitState entries than the card has texture units, the Pass in question will be split into more than one Pass in order to emulate the Pass. If you set this to false and this situation arises, an Exception will be thrown.

void Ogre::Material::copyDetailsTo | ( | MaterialPtr & | mat | ) | const

Copies the details of this material into another, preserving the target's handle and name (unlike operator=) but copying everything else.

Parameters:

  | mat | Weak reference to material which will receive this material's settings.

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const`[virtual, inherited]`

Method for copying this object's parameters to another object.

Remarks:
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters:

  | dest | Pointer to object to have it's parameters set the same as this object.

Definition at line 301 of file OgreStringInterface.h.

References Ogre::ParamDictionary::mParamDefs, and Ogre::StringInterface::setParameter().

bool Ogre::StringInterface::createParamDictionary | ( | const String & | className | ) | `[protected, inherited]`

Internal method for creating a parameter dictionary for the class, if it does not already exist.

Remarks:
  This method will check to see if a parameter dictionary exist for this class yet, and if not will create one. NB you must supply the name of the class (RTTI is not used or performance).

Parameters:

  | className | the name of the class using the dictionary

Returns:
  true if a new dictionary was created, false if it was already there

Definition at line 184 of file OgreStringInterface.h.

References OGRE_LOCK_MUTEX.

Technique* Ogre::Material::createTechnique | ( | void |  | ) |

Creates a new Technique for this Material.

Remarks:
  A Technique is a single way of rendering geometry in order to achieve the effect you are intending in a material. There are many reason why you would want more than one - the main one being to handle variable graphics card abilities; you might have one technique which is impressive but only runs on 4th-generation graphics cards, for example. In this case you will want to create at least one fallback Technique. OGRE will work out which Techniques a card can support and pick the best one.

  If multiple Techniques are available, the order in which they are created is important - the engine will consider lower-indexed Techniques to be preferable to higher-indexed Techniques, ie when asked for the 'best' technique it will return the first one in the technique list which is supported by the hardware.

virtual void Ogre::Resource::escalateLoading | ( |  | ) | `[virtual, inherited]`

Escalates the loading of a background loaded resource.

Remarks:
  If a resource is set to load in the background, but something needs it before it's been loaded, there could be a problem. If the user of this resource really can't wait, they can escalate the loading which basically pulls the loading into the current thread immediately. If the resource is already being loaded but just hasn't quite finished then this method will simply wait until the background load is complete.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Technique* Ogre::Material::getBestTechnique | ( | unsigned short | lodIndex = `0`,
|  | const Renderable * | rend = `0` |
| ) |  |  |

Gets the best supported technique.

Remarks:
  This method returns the lowest-index supported Technique in this material (since lower-indexed Techniques are considered to be better than higher-indexed ones).

  The best supported technique is only available after this material has been compiled, which typically happens on loading the material. Therefore, if this method returns NULL, try calling Material::load.

Parameters:

  | lodIndex | The material lod index to use
  | rend | Optional parameter specifying the Renderable that is requesting this technique. Only used if no valid technique for the active material scheme is found, at which point it is passed to MaterialManager::Listener::handleSchemeNotFound as information.

bool Ogre::Material::getCompilationRequired | ( |  | ) | const

Gets the compilation status of the material.

Returns:
  True if the material needs recompilation.

Definition at line 663 of file OgreMaterial.h.

virtual ResourceManager* Ogre::Resource::getCreator | ( | void |  | ) | `[virtual, inherited]`

Gets the manager which created this resource.

Definition at line 411 of file OgreResource.h.

virtual const String& Ogre::Resource::getGroup | ( | void |  | ) | `[virtual, inherited]`

Gets the group which this resource is a member of.

Reimplemented in Ogre::SkeletonInstance.

Definition at line 399 of file OgreResource.h.

virtual ResourceHandle Ogre::Resource::getHandle | ( | void |  | ) | const`[virtual, inherited]`

Reimplemented in Ogre::SkeletonInstance.

Definition at line 317 of file OgreResource.h.

virtual LoadingState Ogre::Resource::getLoadingState | ( |  | ) | const`[virtual, inherited]`

Returns the current loading state.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 348 of file OgreResource.h.

ushort Ogre::Material::getLodIndex | ( | Real | value | ) | const

Gets the LOD index to use at the given value.

Note:
  The value passed in is the 'transformed' value. If you are dealing with an original source value (e.g. distance), use LodStrategy::transformUserValue to turn this into a lookup value.

const LodStrategy* Ogre::Material::getLodStrategy | ( |  | ) | const

Get lod strategy used by this material.

LodValueIterator Ogre::Material::getLodValueIterator | ( | void |  | ) | const

Gets an iterator over the list of values at which each LOD comes into effect.

Remarks:
  Note that the iterator returned from this method is not totally analogous to the one passed in by calling setLodLevels - the list includes a zero entry at the start (since the highest LOD starts at value 0). Also, the values returned are after being transformed by LodStrategy::transformUserValue.

virtual const String& Ogre::Resource::getName | ( | void |  | ) | const`[virtual, inherited]`

Gets resource name.

Reimplemented in Ogre::SkeletonInstance.

Definition at line 312 of file OgreResource.h.

unsigned short Ogre::Material::getNumLodLevels | ( | unsigned short | schemeIndex | ) | const

Gets the number of levels-of-detail this material has in the given scheme, based on Technique::setLodIndex.

Remarks:
  Note that this will not be up to date until the material has been compiled.

unsigned short Ogre::Material::getNumLodLevels | ( | const String & | schemeName | ) | const

Gets the number of levels-of-detail this material has in the given scheme, based on Technique::setLodIndex.

Remarks:
  Note that this will not be up to date until the material has been compiled.

unsigned short Ogre::Material::getNumSupportedTechniques | ( | void |  | ) | const

Retrieves the number of supported techniques.

unsigned short Ogre::Material::getNumTechniques | ( | void |  | ) | const

Retrieves the number of techniques.

virtual const String& Ogre::Resource::getOrigin | ( | void |  | ) | const`[virtual, inherited]`

Get the origin of this resource, e.g.

a script file name.

Remarks:
  This property will only contain something if the creator of this resource chose to populate it. Script loaders are advised to populate it.

Definition at line 418 of file OgreResource.h.

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | `[inherited]`

Retrieves the parameter dictionary for this class.

Remarks:
  Only valid to call this after createParamDictionary.

Returns:
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

Definition at line 217 of file OgreStringInterface.h.

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const`[inherited]`

Definition at line 222 of file OgreStringInterface.h.

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const`[virtual, inherited]`

Generic parameter retrieval method.

Remarks:
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters:

  | name | The name of the parameter to get

Returns:
  String value of parameter, blank if not found

Definition at line 270 of file OgreStringInterface.h.

References Ogre::ParamCommand::doGet(), and Ogre::ParamDictionary::getParamCommand().

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const`[inherited]`

Retrieves a list of parameters valid for this object.

Returns:
  A reference to a static list of ParameterDef objects.

bool Ogre::Material::getReceiveShadows | ( | void |  | ) | const

Returns whether or not objects using this material will receive shadows.

Definition at line 185 of file OgreMaterial.h.

virtual size_t Ogre::Resource::getSize | ( | void |  | ) | const`[virtual, inherited]`

Retrieves info about the size of the resource.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 301 of file OgreResource.h.

virtual size_t Ogre::Resource::getStateCount | ( |  | ) | const`[virtual, inherited]`

Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.

Objects that build derived data based on the resource can check this value against a copy they kept last time they built this derived data, in order to know whether it needs rebuilding. This is a nice way of monitoring changes without having a tightly-bound callback.

Definition at line 429 of file OgreResource.h.

Technique* Ogre::Material::getSupportedTechnique | ( | unsigned short | index | ) |

Gets the indexed supported technique.

TechniqueIterator Ogre::Material::getSupportedTechniqueIterator | ( | void |  | ) |

Gets an iterator over all the Techniques which are supported by the current card.

Remarks:
  The supported technique list is only available after this material has been compiled, which typically happens on loading the material. Therefore, if this method returns an empty list, try calling Material::load.

Technique* Ogre::Material::getTechnique | ( | const String & | name | ) |

searches for the named technique.

Return 0 if technique with name is not found

Technique* Ogre::Material::getTechnique | ( | unsigned short | index | ) |

Gets the indexed technique.

TechniqueIterator Ogre::Material::getTechniqueIterator | ( | void |  | ) |

Get an iterator over the Techniques in this Material.

bool Ogre::Material::getTransparencyCastsShadows | ( | void |  | ) | const

Returns whether or not objects using this material be classified as opaque to the shadow caster system.

Definition at line 197 of file OgreMaterial.h.

const String& Ogre::Material::getUnsupportedTechniquesExplanation | ( |  | ) | const

Gets a string explaining why any techniques are not supported.

Definition at line 242 of file OgreMaterial.h.

void Ogre::Material::insertSupportedTechnique | ( | Technique * | t | ) | `[protected]`

Insert a supported technique into the local collections.

virtual bool Ogre::Resource::isBackgroundLoaded | ( | void |  | ) | const`[virtual, inherited]`

Returns whether this Resource has been earmarked for background loading.

Remarks:
  This option only makes sense when you have built Ogre with thread support (OGRE_THREAD_SUPPORT). If a resource has been marked for background loading, then it won't load on demand like normal when load() is called. Instead, it will ignore request to load() except if the caller indicates it is the background loader. Any other users of this resource should check isLoaded(), and if that returns false, don't use the resource and come back later.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 365 of file OgreResource.h.

virtual bool Ogre::Resource::isLoaded | ( | void |  | ) | const`[virtual, inherited]`

Returns true if the Resource has been loaded, false otherwise.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 332 of file OgreResource.h.

virtual bool Ogre::Resource::isLoading | ( |  | ) | const`[virtual, inherited]`

Returns whether the resource is currently in the process of background loading.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 341 of file OgreResource.h.

virtual bool Ogre::Resource::isManuallyLoaded | ( | void |  | ) | const`[virtual, inherited]`

Is this resource manually loaded?

Definition at line 289 of file OgreResource.h.

virtual bool Ogre::Resource::isPrepared | ( | void |  | ) | const`[virtual, inherited]`

Returns true if the Resource has been prepared, false otherwise.

Definition at line 324 of file OgreResource.h.

virtual bool Ogre::Resource::isReloadable | ( | void |  | ) | const`[virtual, inherited]`

Returns true if the Resource is reloadable, false otherwise.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 282 of file OgreResource.h.

bool Ogre::Material::isTransparent | ( | void |  | ) | const

Determines if the material has any transparency with the rest of the scene (derived from whether any Techniques say they involve transparency).

virtual void Ogre::Resource::load | ( | bool | backgroundThread = `false` | ) | `[virtual, inherited]`

Loads the resource, if it is not already.

Remarks:
  If the resource is loaded from a file, loading is automatic. If not, if for example this resource gained it's data from procedural calls rather than loading from a file, then this resource will not reload on it's own.

Parameters:

  | backgroundThread | Indicates whether the caller of this method is the background resource loading thread.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

void Ogre::Material::loadImpl | ( | void |  | ) | `[protected, virtual]`

Overridden from Resource.

Implements Ogre::Resource.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 107 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 118 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 72 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 78 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 90 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 85 of file OgreMemoryAllocatedObject.h.

Material& Ogre::Material::operator= | ( | const Material & | rhs | ) |

Assignment operator to allow easy copying between materials.

virtual void Ogre::Resource::postLoadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal hook to perform actions after the load process, but before the resource has been marked as fully loaded.

Note:
  Mutex will have already been acquired by the loading thread. Also, this call will occur even when using a ManualResourceLoader (when loadImpl is not actually called)

Reimplemented in Ogre::Mesh.

Definition at line 189 of file OgreResource.h.

virtual void Ogre::Resource::postUnloadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal hook to perform actions after the unload process, but before the resource has been marked as fully unloaded.

Note:
  Mutex will have already been acquired by the unloading thread.

Definition at line 199 of file OgreResource.h.

virtual void Ogre::Resource::preLoadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal hook to perform actions before the load process, but after the resource has been marked as 'loading'.

Note:
  Mutex will have already been acquired by the loading thread. Also, this call will occur even when using a ManualResourceLoader (when loadImpl is not actually called)

Definition at line 182 of file OgreResource.h.

virtual void Ogre::Resource::prepare | ( | bool | backgroundThread = `false` | ) | `[virtual, inherited]`

Prepares the resource for load, if it is not already.

One can call prepare() before load(), but this is not required as load() will call prepare() itself, if needed. When OGRE_THREAD_SUPPORT==1 both load() and prepare() are thread-safe. When OGRE_THREAD_SUPPORT==2 however, only prepare() is thread-safe. The reason for this function is to allow a background thread to do some of the loading work, without requiring the whole render system to be thread-safe. The background thread would call prepare() while the main render loop would later call load(). So long as prepare() remains thread-safe, subclasses can arbitrarily split the work of loading a resource between load() and prepare(). It is best to try and do as much work in prepare(), however, since this will leave less work for the main render thread to do and thus increase FPS.

Parameters:

  | backgroundThread | Whether this is occurring in a background thread

void Ogre::Material::prepareImpl | ( | void |  | ) | `[protected, virtual]`

Overridden from Resource.

Reimplemented from Ogre::Resource.

virtual void Ogre::Resource::preUnloadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal hook to perform actions before the unload process.

Note:
  Mutex will have already been acquired by the unloading thread.

Definition at line 194 of file OgreResource.h.

virtual void Ogre::Resource::reload | ( | void |  | ) | `[virtual, inherited]`

Reloads the resource, if it is already loaded.

Remarks:
  Calls unload() and then load() again, if the resource is already loaded. If it is not loaded already, then nothing happens.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

void Ogre::Material::removeAllTechniques | ( | void |  | ) |

Removes all the techniques in this Material.

virtual void Ogre::Resource::removeListener | ( | Listener * | lis | ) | `[virtual, inherited]`

Remove a listener on this resource.

See also:
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

void Ogre::Material::removeTechnique | ( | unsigned short | index | ) |

Removes the technique at the given index.

void Ogre::Material::setAmbient | ( | Real | red,
|  | Real | green,
|  | Real | blue |
| ) |  |  |

Sets the ambient colour reflectance properties for every Pass in every Technique.

Note:
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also:
  Pass::setAmbient

void Ogre::Material::setAmbient | ( | const ColourValue & | ambient | ) |

Sets the ambient colour reflectance properties for every Pass in every Technique.

Note:
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also:
  Pass::setAmbient

virtual void Ogre::Resource::setBackgroundLoaded | ( | bool | bl | ) | `[virtual, inherited]`

Tells the resource whether it is background loaded or not.

Remarks:

See also:
  Resource::isBackgroundLoaded . Note that calling this only defers the normal on-demand loading behaviour of a resource, it does not actually set up a thread to make sure the resource gets loaded in the background. You should use ResourceBackgroundLoadingQueue to manage the actual loading (which will call this method itself).

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 375 of file OgreResource.h.

void Ogre::Material::setColourWriteEnabled | ( | bool | enabled | ) |

Sets whether or not colour buffer writing is enabled for each Pass.

Note:
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also:
  Pass::setColourWriteEnabled

void Ogre::Material::setCullingMode | ( | CullingMode | mode | ) |

Sets the culling mode for each pass based on the 'vertex winding'.

Note:
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also:
  Pass::setCullingMode

void Ogre::Material::setDepthBias | ( | float | constantBias,
|  | float | slopeScaleBias |
| ) |  |  |

Sets the depth bias to be used for each Pass.

Note:
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also:
  Pass::setDepthBias

void Ogre::Material::setDepthCheckEnabled | ( | bool | enabled | ) |

Sets whether or not each Pass renders with depth-buffer checking on or not.

Note:
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also:
  Pass::setDepthCheckEnabled

void Ogre::Material::setDepthFunction | ( | CompareFunction | func | ) |

Sets the function used to compare depth values when depth checking is on.

Note:
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also:
  Pass::setDepthFunction

void Ogre::Material::setDepthWriteEnabled | ( | bool | enabled | ) |

Sets whether or not each Pass renders with depth-buffer writing on or not.

Note:
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also:
  Pass::setDepthWriteEnabled

void Ogre::Material::setDiffuse | ( | const ColourValue & | diffuse | ) |

Sets the diffuse colour reflectance properties of every Pass in every Technique.

Note:
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also:
  Pass::setDiffuse

void Ogre::Material::setDiffuse | ( | Real | red,
|  | Real | green,
|  | Real | blue,
|  | Real | alpha |
| ) |  |  |

Sets the diffuse colour reflectance properties of every Pass in every Technique.

Note:
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also:
  Pass::setDiffuse

void Ogre::Material::setFog | ( | bool | overrideScene,
|  | FogMode | mode = `FOG_NONE`,
|  | const ColourValue & | colour = `ColourValue::White`,
|  | Real | expDensity = `0.001`,
|  | Real | linearStart = `0.0`,
|  | Real | linearEnd = `1.0` |
| ) |  |  |

Sets the fogging mode applied to each pass.

Note:
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also:
  Pass::setFog

void Ogre::Material::setLightingEnabled | ( | bool | enabled | ) |

Sets whether or not dynamic lighting is enabled for every Pass.

Note:
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also:
  Pass::setLightingEnabled

void Ogre::Material::setLodLevels | ( | const LodValueList & | lodValues | ) |

Sets the distance at which level-of-detail (LOD) levels come into effect.

Remarks:
  You should only use this if you have assigned LOD indexes to the Technique instances attached to this Material. If you have done so, you should call this method to determine the distance at which the lowe levels of detail kick in. The decision about what distance is actually used is a combination of this and the LOD bias applied to both the current Camera and the current Entity.

Parameters:

  | lodValues | A vector of Reals which indicate the lod value at which to switch to lower details. They are listed in LOD index order, starting at index 1 (ie the first level down from the highest level 0, which automatically applies from a value of 0). These are 'user values', before being potentially transformed by the strategy, so for the distance strategy this is an unsquared distance for example.

void Ogre::Material::setLodStrategy | ( | LodStrategy * | lodStrategy | ) |

Set the lod strategy used by this material.

void Ogre::Material::setManualCullingMode | ( | ManualCullingMode | mode | ) |

Sets the manual culling mode, performed by CPU rather than hardware.

Note:
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also:
  Pass::setManualCullingMode

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value |
| ) |  |  | `[virtual, inherited]`

Generic parameter setting method.

Remarks:
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | name | The name of the parameter to set
  | value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns:
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

Referenced by Ogre::StringInterface::copyParametersTo().

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) | `[virtual, inherited]`

Generic multiple parameter setting method.

Remarks:
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | paramList | Name/value pair list

void Ogre::Material::setPointSize | ( | Real | ps | ) |

Sets the point size properties for every Pass in every Technique.

Note:
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also:
  Pass::setPointSize

void Ogre::Material::setReceiveShadows | ( | bool | enabled | ) |

Sets whether objects using this material will receive shadows.

Remarks:
  This method allows a material to opt out of receiving shadows, if it would otherwise do so. Shadows will not be cast on any objects unless the scene is set up to support shadows (

See also:
  SceneManager::setShadowTechnique), and not all techniques cast shadows on all objects. In any case, if you have a need to prevent shadows being received by material, this is the method you call to do it.

Note:
  Transparent materials never receive shadows despite this setting. The default is to receive shadows.

Definition at line 183 of file OgreMaterial.h.

void Ogre::Material::setSceneBlending | ( | const SceneBlendFactor | sourceFactor,
|  | const SceneBlendFactor | destFactor |
| ) |  |  |

Allows very fine control of blending every Pass with the existing contents of the scene.

Note:
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also:
  Pass::setSceneBlending

void Ogre::Material::setSceneBlending | ( | const SceneBlendType | sbt | ) |

Sets the kind of blending every pass has with the existing contents of the scene.

Note:
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also:
  Pass::setSceneBlending

void Ogre::Material::setSelfIllumination | ( | Real | red,
|  | Real | green,
|  | Real | blue |
| ) |  |  |

Sets the amount of self-illumination of every Pass in every Technique.

Note:
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also:
  Pass::setSelfIllumination

void Ogre::Material::setSelfIllumination | ( | const ColourValue & | selfIllum | ) |

Sets the amount of self-illumination of every Pass in every Technique.

Note:
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also:
  Pass::setSelfIllumination

void Ogre::Material::setSeparateSceneBlending | ( | const SceneBlendFactor | sourceFactor,
|  | const SceneBlendFactor | destFactor,
|  | const SceneBlendFactor | sourceFactorAlpha,
|  | const SceneBlendFactor | destFactorAlpha |
| ) |  |  |

Allows very fine control of blending every Pass with the existing contents of the scene, using individual factors for color and alpha channels.

Note:
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also:
  Pass::setSeparateSceneBlending

void Ogre::Material::setSeparateSceneBlending | ( | const SceneBlendType | sbt,
|  | const SceneBlendType | sbta |
| ) |  |  |

Sets the kind of blending every pass has with the existing contents of the scene, using individual factors for color and alpha channels.

Note:
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also:
  Pass::setSeparateSceneBlending

void Ogre::Material::setShadingMode | ( | ShadeOptions | mode | ) |

Sets the type of light shading required.

Note:
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also:
  Pass::setShadingMode

void Ogre::Material::setShininess | ( | Real | val | ) |

Sets the shininess properties of every Pass in every Technique.

Note:
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also:
  Pass::setShininess

void Ogre::Material::setSpecular | ( | const ColourValue & | specular | ) |

Sets the specular colour reflectance properties of every Pass in every Technique.

Note:
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also:
  Pass::setSpecular

void Ogre::Material::setSpecular | ( | Real | red,
|  | Real | green,
|  | Real | blue,
|  | Real | alpha |
| ) |  |  |

Sets the specular colour reflectance properties of every Pass in every Technique.

Note:
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also:
  Pass::setSpecular

void Ogre::Material::setTextureAnisotropy | ( | int | maxAniso | ) |

Sets the anisotropy level to be used for all textures.

Note:
  This property has been moved to the TextureUnitState class, which is accessible via the Technique and Pass. For simplicity, this method allows you to set these properties for every current TeextureUnitState, If you need more precision, retrieve the Technique, Pass and TextureUnitState instances and set the property there.

See also:
  TextureUnitState::setTextureAnisotropy

void Ogre::Material::setTextureFiltering | ( | TextureFilterOptions | filterType | ) |

Set texture filtering for every texture unit in every Technique and Pass.

Note:
  This property has been moved to the TextureUnitState class, which is accessible via the Technique and Pass. For simplicity, this method allows you to set these properties for every current TeextureUnitState, If you need more precision, retrieve the Technique, Pass and TextureUnitState instances and set the property there.

See also:
  TextureUnitState::setTextureFiltering

void Ogre::Material::setTransparencyCastsShadows | ( | bool | enabled | ) |

Sets whether objects using this material be classified as opaque to the shadow caster system.

Remarks:
  This method allows a material to cast a shadow, even if it is transparent. By default, transparent materials neither cast nor receive shadows. Shadows will not be cast on any objects unless the scene is set up to support shadows (

See also:
  SceneManager::setShadowTechnique), and not all techniques cast shadows on all objects.

Definition at line 195 of file OgreMaterial.h.

void Ogre::Material::touch | ( | void |  | ) | `[virtual]`

'Touches' the resource to indicate it has been used.

Reimplemented from Ogre::Resource.

Definition at line 639 of file OgreMaterial.h.

References Ogre::Resource::touch().

virtual void Ogre::Resource::unload | ( | void |  | ) | `[virtual, inherited]`

Unloads the resource; this is not permanent, the resource can be reloaded later if required.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

void Ogre::Material::unloadImpl | ( | void |  | ) | `[protected, virtual]`

Unloads the material, frees resources etc.

See also:
  Resource

Implements Ogre::Resource.

void Ogre::Material::unprepareImpl | ( | void |  | ) | `[protected, virtual]`

Overridden from Resource.

Reimplemented from Ogre::Resource.

## Friends And Related Function Documentation

friend class MaterialManager`[friend]`

Definition at line 91 of file OgreMaterial.h.

friend class SceneManager`[friend]`

Definition at line 90 of file OgreMaterial.h.

## Member Data Documentation

BestTechniquesBySchemeList Ogre::Material::mBestTechniquesBySchemeList`[protected]`

Map of scheme -> list of LOD techniques.

Current scheme is set on MaterialManager, and can be set per Viewport for auto activation.

Definition at line 115 of file OgreMaterial.h.

bool Ogre::Material::mCompilationRequired`[protected]`

Does this material require compilation?

Definition at line 123 of file OgreMaterial.h.

ResourceManager* Ogre::Resource::mCreator`[protected, inherited]`

Creator.

Definition at line 142 of file OgreResource.h.

String Ogre::Resource::mGroup`[protected, inherited]`

The name of the resource group.

Definition at line 146 of file OgreResource.h.

ResourceHandle Ogre::Resource::mHandle`[protected, inherited]`

Numeric handle for more efficient look up than name.

Definition at line 148 of file OgreResource.h.

volatile bool Ogre::Resource::mIsBackgroundLoaded`[protected, inherited]`

Is this resource going to be background loaded? Only applicable for multithreaded.

Definition at line 152 of file OgreResource.h.

bool Ogre::Resource::mIsManual`[protected, inherited]`

Is this file manually loaded?

Definition at line 156 of file OgreResource.h.

ListenerList Ogre::Resource::mListenerList`[protected, inherited]`

Definition at line 165 of file OgreResource.h.

ManualResourceLoader* Ogre::Resource::mLoader`[protected, inherited]`

Optional manual loader; if provided, data is loaded from here instead of a file.

Definition at line 160 of file OgreResource.h.

AtomicScalar<LoadingState> Ogre::Resource::mLoadingState`[protected, inherited]`

Is the resource currently loaded?

Definition at line 150 of file OgreResource.h.

const LodStrategy* Ogre::Material::mLodStrategy`[protected]`

Definition at line 119 of file OgreMaterial.h.

LodValueList Ogre::Material::mLodValues`[protected]`

Definition at line 118 of file OgreMaterial.h.

String Ogre::Resource::mName`[protected, inherited]`

Unique name of the resource.

Definition at line 144 of file OgreResource.h.

String Ogre::Resource::mOrigin`[protected, inherited]`

Origin of this resource (e.g. script name) - optional.

Definition at line 158 of file OgreResource.h.

bool Ogre::Material::mReceiveShadows`[protected]`

Definition at line 120 of file OgreMaterial.h.

size_t Ogre::Resource::mSize`[protected, inherited]`

The size of the resource in bytes.

Definition at line 154 of file OgreResource.h.

size_t Ogre::Resource::mStateCount`[protected, inherited]`

State count, the number of times this resource has changed state.

Definition at line 162 of file OgreResource.h.

Techniques Ogre::Material::mSupportedTechniques`[protected]`

Supported techniques of any sort.

Definition at line 108 of file OgreMaterial.h.

Techniques Ogre::Material::mTechniques`[protected]`

All techniques, supported and unsupported.

Definition at line 106 of file OgreMaterial.h.

bool Ogre::Material::mTransparencyCastsShadows`[protected]`

Definition at line 121 of file OgreMaterial.h.

String Ogre::Material::mUnsupportedReasons`[protected]`

Text description of why any techniques are not supported.

Definition at line 125 of file OgreMaterial.h.

LodValueList Ogre::Material::mUserLodValues`[protected]`

Definition at line 117 of file OgreMaterial.h.

The documentation for this class was generated from the following file:

- OgreMaterial.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:24:56